Copy paste records in EJ2 JavaScript Gantt control

2 May 20236 minutes to read

You can copy and paste a record in the Gantt chart by using the addRecord method and custom context menu. It is also possible to copy and paste the parent record with multiple hierarchical child records on the required position.

ej.base.enableRipple(true);
var copiedRecord;
var enableFlag;
var gantt = new ej.gantt.Gantt({
        dataSource: GanttData,
		height:'450px',
		taskFields: {
            id: 'TaskID',
        	name: 'TaskName',
        	startDate: 'StartDate',
        	dependency: 'Predecessor',
        	duration: 'Duration',
        	progress: 'Progress',
        	child: 'subtasks'
        },
    editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true 
    },
    toolbar: ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'],
    allowSelection: true,
    enableContextMenu: true,
    contextMenuItems: [
        { text: 'Copy', target: '.e-content', id: 'copy' },
        { text: 'Paste', target: '.e-content', id: 'paste' },
    ],
    contextMenuClick: function (args) {
        if (args.item.id === 'copy') {
            copiedRecord = args.rowData;
            copiedRecord.taskData.TaskID = gantt.currentViewData.length + 1;
        }
        if (args.item.id === 'paste') {
            gantt.addRecord(copiedRecord.taskData,'Below',args.rowData.index);
            if(copiedRecord.hasChildRecords) {
                addChildRecords(copiedRecord, args.rowData.index + 1);
            }
            copiedRecord = undefined;
        }
    },
    contextMenuOpen: function (args) {
        if (args.type !== 'Header') {
            if (copiedRecord) {
                args.hideItems.push('Copy');
            } else {
                args.hideItems.push('Paste');
             }
        }
    }
});

gantt.appendTo('#Gantt');

    function addChildRecords(record, index) {
      for(var i=0; i<record.childRecords.length; i++) {
            var childRecord = record.childRecords[i];
            childRecord.taskData.TaskID = ganttChart.currentViewData.length + 1;
            ganttChart.addRecord(childRecord.taskData,'Child',index);
            if(childRecord.hasChildRecords) {
                addChildRecords(childRecord, index + (i+1));
            }
      }
    }
<!DOCTYPE html><html lang="en"><head>
     <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
	<link href="https://cdn.syncfusion.com/ej2/30.1.37/material.css" rel="stylesheet" type="text/css">
    
    
<script src="https://cdn.syncfusion.com/ej2/30.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       
     
    <div id="container">	   
        <div id="Gantt"></div>        
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Copy paste records in React Gantt component

2 Feb 202311 minutes to read

You can copy and paste a record in the Gantt chart by using the addRecord method and custom context menu. It is also possible to copy and paste the parent record with multiple hierarchical child records on the required position.

import React, { useRef } from 'react';
import ReactDOM from 'react-dom';
import {
  GanttComponent,
  Inject,
  Edit,
  Selection,
  ContextMenu,
} from '@syncfusion/ej2-react-gantt';
import { taskData } from './datasource';

function App() {
  const ganttRef = useRef(null);
  let copiedRecord;

  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    parentID: 'ParentId'
  };

  const editSettings = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true,
  };

  const contextMenuItems = [
    { text: 'Copy', target: '.e-content', id: 'copy' },
    { text: 'Paste', target: '.e-content', id: 'paste' },
  ];

  const contextMenuClick = (args) => {
    if (args.item.id === 'copy') {
      copiedRecord = args.rowData;
      // Generate a new TaskID
      copiedRecord.taskData.TaskID = ganttRef.current.currentViewData.length + 1;
    }

    if (args.item.id === 'paste' && copiedRecord) {
        ganttRef.current.addRecord(
        copiedRecord.taskData,
        'Below',
        args.rowData?.index
      );
      if (copiedRecord.hasChildRecords) {
        addChildRecords(copiedRecord, args.rowData?.index + 1);
      }
      copiedRecord = undefined; // Clear copied record after pasting
    }
  };

  const contextMenuOpen = (args) => {
    if (args.type !== 'Header') {
      if (copiedRecord) {
        args.hideItems.push('Copy'); // Hide "Copy" if already copied
      } else {
        args.hideItems.push('Paste'); // Hide "Paste" if nothing is copied
      }
    }
  };

  const addChildRecords = (record, index) => {
    record.childRecords.forEach((childRecord, i) => {
      childRecord.taskData.TaskID = ganttRef.current.currentViewData.length + 1;
      ganttRef.current.addRecord(childRecord.taskData, 'Below', index + i);

      if (childRecord.hasChildRecords) {
        addChildRecords(childRecord, index + i + 1);
      }
    });
  };

  return (
    <GanttComponent
      dataSource={taskData}
      taskFields={taskFields}
      editSettings={editSettings}
      enableContextMenu={true}
      contextMenuItems={contextMenuItems}
      contextMenuClick={contextMenuClick}
      contextMenuOpen={contextMenuOpen}
      ref={ganttRef}
      height="450px"
    >
      <Inject services={[Edit, ContextMenu, Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
import React, { useRef } from 'react';
import ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, Selection, ContextMenu, Gantt } from '@syncfusion/ej2-react-gantt';
import { taskData } from './datasource';

function App() {
  const ganttRef = useRef<Gantt | null>(null);

  let copiedRecord: any = null;

  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    parentID: 'ParentId'
  };

  const editSettings = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true,
  };

  // Context menu items as a plain array
  const contextMenuItems = [
    { text: 'Copy', target: '.e-content', id: 'copy' },
    { text: 'Paste', target: '.e-content', id: 'paste' },
  ];

  const contextMenuClick = (args: any): void => {
    const gantt = ganttRef.current;

    if (!gantt) return;

    if (args.item.id === 'copy') {
      copiedRecord = args.rowData;
      copiedRecord.taskData.TaskID = gantt.currentViewData.length + 1; // Assign unique TaskID
    }

    if (args.item.id === 'paste' && copiedRecord) {
      gantt.addRecord(copiedRecord.taskData, 'Below', args.rowData.index);

      if (copiedRecord.hasChildRecords) {
        addChildRecords(copiedRecord, args.rowData.index + 1);
      }

      copiedRecord = null;
    }
  };

  const contextMenuOpen = (args: any): void => {
    if (args.type !== 'Header') {
      if (copiedRecord) {
        args.hideItems.push('Copy');
      } else {
        args.hideItems.push('Paste');
      }
    }
  };

  const addChildRecords = (record: any, index: number): void => {
    const gantt = ganttRef.current;

    if (!gantt) return;

    record.childRecords.forEach((childRecord: any, i: number) => {
      childRecord.taskData.TaskID = gantt.currentViewData.length + 1; // Assign unique TaskID
      gantt.addRecord(childRecord.taskData, 'Below', index + i);

      if (childRecord.hasChildRecords) {
        addChildRecords(childRecord, index + i + 1);
      }
    });
  };

  return (
    <GanttComponent
      dataSource={taskData}
      taskFields={taskFields}
      editSettings={editSettings}
      enableContextMenu={true}
      contextMenuItems={contextMenuItems}
      contextMenuClick={contextMenuClick}
      contextMenuOpen={contextMenuOpen}
      ref={(gantt) => (ganttRef.current = gantt)}
      height="450px"
    >
      <Inject services={[Edit, ContextMenu, Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/30.1.37/material.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Copy paste records in Angular Gantt component

17 May 20256 minutes to read

You can copy and paste a record in the Gantt chart by using the addRecord method and custom context menu. It is also possible to copy and paste the parent record with multiple hierarchical child records on the required position.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { GanttModule, ContextMenuService, EditService, SelectionService } from '@syncfusion/ej2-angular-gantt'
import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { GanttComponent, ContextMenuClickEventArgs, ContextMenuOpenEventArgs } from '@syncfusion/ej2-angular-gantt';
import { ContextMenuItemModel } from '@syncfusion/ej2-grids';
import { editingData} from './data';

@Component({
imports: [
         GanttModule
    ],

providers: [SelectionService, ContextMenuService, EditService],
standalone: true,
    selector: 'app-root',
    template:
       `<ejs-gantt #customcontextmenu id="ganttCustomContextmenu" height="430px" [dataSource]="editingData" [taskFields]="taskSettings" [enableContextMenu]="true" [contextMenuItems]="contextMenuItems" [editSettings]="editSettings" (contextMenuClick)="contextMenuClick($event)" (contextMenuOpen)="contextMenuOpen($event)"></ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent{
    // Data for Gantt
    public copiedRecord?: any;
    public editingData?: object[];
    public taskSettings?: object;
    public editSettings?: object;
    public contextMenuItems?: (string | ContextMenuItemModel)[];
    @ViewChild('customcontextmenu', {static: true})
    public ganttObj?: GanttComponent| any;
    public ngOnInit(): void {
        this.editingData = editingData;
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            parentID:'ParentID',
        };
        this.editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
       };
       this.contextMenuItems = [{ text: 'Copy', target: '.e-content', id: 'copy' } as ContextMenuItemModel,
        { text: 'Paste', target: '.e-content', id: 'paste' } as ContextMenuItemModel,
        ];
    }
    public contextMenuClick (args: ContextMenuClickEventArgs) {
        if (args.item.id === 'copy') {
            this.copiedRecord = args.rowData;
            this.copiedRecord.taskData.TaskID = this.ganttObj.currentViewData.length + 1;
        }
        if (args.item.id === 'paste') {
            this.ganttObj.addRecord(this.copiedRecord.taskData,'Below',args.rowData!.index);
            if(this.copiedRecord.hasChildRecords) {
                addChildRecords(this.copiedRecord, args.rowData!.index! + 1);
            }
            this.copiedRecord = undefined;
        }
    }
    public contextMenuOpen (args: ContextMenuOpenEventArgs) {
        if (args.type !== 'Header') {
            if (this.copiedRecord) {
                args.hideItems!.push('Copy');
            } else {
                args.hideItems!.push('Paste');
             }
        }
    }
}

function addChildRecords(this: any, record: any, index: any): void {
    for(var i=0; i<record.childRecords.length; i++) {
          var childRecord = record.childRecords[i];
          childRecord.taskData.TaskID = this.ganttObj.currentViewData.length + 1;
          this.ganttObj.addRecord(childRecord.taskData,'Child',index);
          if(childRecord.hasChildRecords) {
              addChildRecords(childRecord, index + (i+1));
          }
    }
  }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));